#-----------------------------------------------------------------------------

# Copier
# Jan 28, 2005
# Copyright (c) 2005, David G. Drumright [ockham]

#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import sys
import os
import poser

scene = poser.Scene()

SrcActorName=''
SrcActor=scene.CurrentActor()
SrcActorName=SrcActor.Name()
try:
    SrcFigure=SrcActor.ItsFigure()
except:
    SrcFigure=0

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Copier")

        self.SrcFrame=Frame(self.master,borderwidth=2,relief=RIDGE)
        self.DstFrame=Frame(self.master,borderwidth=2,relief=RIDGE)
        self.SrcFrame.grid(row=0,column=0,sticky=N+S+E,pady=2)
        self.DstFrame.grid(row=0,column=1,sticky=N+S+E,pady=2)
        self.ButFrame=Frame(self.master,borderwidth=2,relief=RIDGE)
        self.ButFrame.grid(row=2,column=0,sticky=N+S+E,pady=2,columnspan=2)

        #-------

        APtext="Source %s Parms:" % SrcActor.Name()
        Label(self.SrcFrame,text=APtext).grid(row=0, column=1,sticky=N)
        self.SrcParmScroll=Scrollbar(self.SrcFrame, orient=VERTICAL)
        self.SrcParmScroll.grid(row=1, column=0,sticky=N+S+E)
        self.SrcParmList=Listbox(self.SrcFrame, height=15, selectmode=SINGLE,yscrollcommand=self.SrcParmScroll.set,exportselection=0)
        self.SrcParmList.grid( row=1, column=1,columnspan=2)
        self.SrcParmScroll["command"]=self.SrcParmList.yview

        Label(self.SrcFrame,text="Start").grid(row=2,column=0)
        self.SrcStartEntry=Entry(self.SrcFrame,width=8)
        self.SrcStartEntry.grid(row=2,column=1,sticky=W,pady=3)

        Label(self.SrcFrame,text="End").grid(row=3,column=0,pady=3)
        self.SrcEndEntry=Entry(self.SrcFrame,width=8)
        self.SrcEndEntry.grid(row=3,column=1,sticky=W,pady=3)

        Label(self.SrcFrame,text="Range").grid(row=2,column=2,pady=3)
        self.SrcMultEntry = Entry(self.SrcFrame,width=8)
        self.SrcMultEntry.grid(row=2,column=3,sticky=W,pady=3)

        #-------

        Label(self.DstFrame,text="Dest parts (DOUBLE-CLICK)").grid(row=0, column=1,sticky=N)
        self.DstActorScroll=Scrollbar(self.DstFrame, orient=VERTICAL)
        self.DstActorScroll.grid(row=1, column=0,sticky=N+S+E)
        self.DstActorList=Listbox(self.DstFrame, height=15, selectmode=MULTIPLE,yscrollcommand=self.DstActorScroll.set,exportselection=0)
        self.DstActorList.grid( row=1, column=1)
        self.DstActorScroll["command"]=self.DstActorList.yview

        Label(self.DstFrame,text="Dest Parms:").grid(row=0, column=3,sticky=N)
        self.DstParmScroll=Scrollbar(self.DstFrame, orient=VERTICAL)
        self.DstParmScroll.grid(row=1, column=2,sticky=N+S+E)
        self.DstParmList=Listbox(self.DstFrame, height=15, selectmode=MULTIPLE,yscrollcommand=self.DstParmScroll.set,exportselection=0)
        self.DstParmList.grid( row=1, column=3)
        self.DstParmScroll["command"]=self.DstParmList.yview

        Label(self.DstFrame,text="Start").grid(row=2,column=0)
        self.DstStartEntry=Entry(self.DstFrame,width=8)
        self.DstStartEntry.grid(row=2,column=1,sticky=W,pady=3)

        Label(self.DstFrame,text="End").grid(row=3,column=0,pady=3)
        self.DstEndEntry=Entry(self.DstFrame,width=8)
        self.DstEndEntry.grid(row=3,column=1,sticky=W,pady=3)

        Label(self.DstFrame,text="Range").grid(row=2,column=2,pady=3)
        self.DstMultEntry = Entry(self.DstFrame,width=8)
        self.DstMultEntry.grid(row=2,column=3,sticky=W,pady=3)

        #-------

        # Fill the lists.
        self.FillSrcParmList()
        self.FillDstActorList()
        #self.FillDstParmList() # This doesn't happen until you select a Dst actor.



        # Put defaults
        self.SrcMultEntry.insert(0,str(1.0))
        self.DstMultEntry.insert(0,str(1.0))
        # Note: fill only the source start. Leave dest empty so we
        # can tell if you want something different there.
        self.SrcStartEntry.insert(0,str(1))
        self.SrcEndEntry.insert(0,str(scene.NumFrames()))

        # Go/nogo buttons.
        self.buttonGo = Button(self.ButFrame, text="Go", command=self.HandleGo)
        self.buttonGo.grid(row=1, column=0,sticky=E+W,pady=3)

        self.buttonCancel = Button(self.ButFrame, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=1, column=2,sticky=E+W,pady=3)

        # List binding to get the parms of the Dst.
        self.DstActorList.bind("<Double-Button-1>",self.FillDstParmList)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)

    # - - - - - - - - - - - - - - - - - -

    def FillSrcParmList(self):
        # Clear then refill the Parm list
        # In the visible list, add the part that the mag is on.
        self.SrcParmList.delete(0,END) # clear the visible
        for OneParm in SrcActor.Parameters():
            if not OneParm.Hidden():
                self.SrcParmList.insert(END,OneParm.Name())

    # - - - - - - - - - - - - - - - - - -

    def FillDstParmList(self,event):
        # Called by double-click on DstActor.  First get the
        # Actor, then its parms.
        Sels=event.widget.curselection()
        st=event.widget.get(int(Sels[0]))
        Parts=string.split(st,':')
        if len(Parts)<2:
            self.DstFigName=None
            self.DstActorName=st
            DstActor=scene.Actor(st) # Actor itself is temp
        else:
            self.DstFigName=Parts[1]  # Names are perm
            self.DstActorName=Parts[0]
            FolFig=scene.Figure(Parts[1]) # Fig is temp
            DstActor=FolFig.Actor(Parts[0]) # Actor itself is temp
        # Clear then refill the Parm list
        # In the visible list, add the part that the mag is on.

        self.DstParmList.delete(0,END) # clear the visible
        for OneParm in DstActor.Parameters():
            if not OneParm.Hidden():
                self.DstParmList.insert(END,OneParm.Name())

    # - - - - - - - - - - - - - - - - - -

    def FillDstActorList(self):
        self.DstActorList.delete(0,END) # clear the visible
        for OneActor in scene.Actors():
            # Put actor first, then fig, so we can split at the left parenthesis.
            Fig = OneActor.ItsFigure()
            if Fig:
                st='%s:%s' % (OneActor.Name(), Fig.Name())
            else:
                st= OneActor.Name()
            self.DstActorList.insert(END,st)

    # - - - - - - - - - - - - - - - - - -

    def Action(self):
        # Get the numbers first:

        SrcStartString = self.SrcStartEntry.get()
        SrcEndString   = self.SrcEndEntry.get()
        SrcMultString  = self.SrcMultEntry.get()

        DstStartString = self.DstStartEntry.get()
        DstEndString   = self.DstEndEntry.get()
        DstMultString  = self.DstMultEntry.get()

        # You're supposed to give the range of source and dest,
        # and we then divide d/s to get the multiplier. (Saving
        # you from a bit of calcing.)
        if SrcMultString:
            SrcMult = float(SrcMultString)
        else:
            SrcMult = 1.0  # No change if you miss

        if DstMultString:
            DstMult = float(DstMultString)
        else:
            DstMult = 1.0  # No change if you miss

        if DstMult==0.0: Multiplier=1.0
        else: Multiplier = DstMult / SrcMult

        # Begin by assuming that source and dest frames are same.
        # Only make dest different when dest entries are found.
        if SrcStartString:
            SrcStartFrame = int(SrcStartString)
            DstStartFrame = int(SrcStartString)
        else:
            SrcStartFrame = 1
            DstStartFrame = 1

        if SrcEndString:
            SrcEndFrame = int(SrcEndString)
            DstEndFrame = int(SrcEndString)
        else:
            SrcEndFrame = scene.NumFrames()
            DstEndFrame = scene.NumFrames()

        # Assign dest frames differently only if entries:
        if DstStartString:
            DstStartFrame = int(DstStartString)
        else:
            DstStartFrame = 1

        if DstEndString:
            DstEndFrame = int(DstEndString)
        else:
            DstEndFrame = scene.NumFrames()

        # Get the selections.  Note that we already have both the Actors;
        # the Src by preselection and the Dst by doubleclick.
        # We only need to get the parms here.
        SrcParmSels=self.SrcParmList.curselection() # single
        if not SrcParmSels:
            return
        SrcParmName=self.SrcParmList.get(int(SrcParmSels[0]))
        SrcParm=SrcActor.Parameter(SrcParmName)

        if self.DstFigName:
            FolFig=scene.Figure(self.DstFigName)
            DstActor=FolFig.Actor(self.DstActorName) # Actor itself is temp
        else:
            DstActor=scene.Actor(self.DstActorName)

        DstParmSels=self.DstParmList.curselection() # multiple
        if not DstParmSels:
            return

        # After all the getting, here's the real action.
        # We work on the basis of deltas here, to avoid the whole question
        # of offsets and defaults.

        # First check the frames.  If dest != source, run by interpolation;
        # if same, run direct.
        UseInterp=0
        Interps=[]
        if (DstStartFrame != SrcStartFrame) or (DstEndFrame != SrcEndFrame):
            UseInterp=1
            # Copy with interp.  For convenience, first build a separate array
            # of the deltas needed in the dest range.
            DstDenom=float(DstEndFrame-DstStartFrame)
            SrcDenom=float(SrcEndFrame-SrcStartFrame)
            for F in range(DstStartFrame,DstEndFrame+1):
                RelDstFrame1=F-DstStartFrame
                RelDstFrame2=RelDstFrame1+1
                DstPro1=float(RelDstFrame1)/DstDenom
                DstPro2=float(RelDstFrame2)/DstDenom
                SrcFrame1=int(float(SrcStartFrame) + DstPro1 * SrcDenom)
                SrcFrame2=int(float(SrcStartFrame) + DstPro2 * SrcDenom)
                scene.SetFrame(SrcFrame1-1)
                Src1=SrcParm.Value()
                scene.SetFrame(SrcFrame2-1)
                Src2=SrcParm.Value()
                Interps.append(Src2-Src1) # This is the delta for the relative dest frame.


            for OneSel in DstParmSels:
                OneParmName = self.DstParmList.get(int(OneSel))
                OneDstParm = DstActor.Parameter(OneParmName)
                # First go through and pin down the Dst so we don't
                # push splines.
                for F in range(DstStartFrame,DstEndFrame+1):
                    scene.SetFrame(F-1)
                    OneDstParm.AddKeyFrame(F-1)
                    OneDstParm.SetSplineBreak(F-1)

                # Now move the Dst by delta * multiplier
                for F in range(DstStartFrame,DstEndFrame):
                    scene.SetFrame(F-1)
                    Dst1=OneDstParm.Value()
                    scene.SetFrame(F)
                    # For delta here, use the Interps element for relative dest.
                    Delta=Interps[F-DstStartFrame]
                    OneDstParm.SetValue(Dst1 + Delta * Multiplier)

        else: # Copy at same frame.
            for OneSel in DstParmSels:
                OneParmName = self.DstParmList.get(int(OneSel))
                OneDstParm = DstActor.Parameter(OneParmName)
                # First go through and pin down the Dst so we don't
                # push splines.
                for F in range(DstStartFrame,DstEndFrame+1):
                    scene.SetFrame(F-1)
                    OneDstParm.AddKeyFrame(F-1)
                    OneDstParm.SetSplineBreak(F-1)

                # Now move the Dst by delta * multiplier
                for F in range(DstStartFrame,DstEndFrame):
                    scene.SetFrame(F-1)
                    Src1=SrcParm.Value()
                    Dst1=OneDstParm.Value()

                    scene.SetFrame(F)
                    Src2=SrcParm.Value()
                    Delta=Src2-Src1

                    OneDstParm.SetValue(Dst1 + Delta * Multiplier)


    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        self.Action()
        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
